# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Classes

* [`acsc_e8_office_hardening`](#acsc_e8_office_hardening): A module which enforces https://github.com/benjamin-robertson/acsc_e8_office_hardening/blob/main/PROTECT%20-%20Microsoft%20Office%20Macro%20S
* [`acsc_e8_office_hardening::clear_unused_registry_values`](#acsc_e8_office_hardening--clear_unused_registry_values): Private class
* [`acsc_e8_office_hardening::disable_flash`](#acsc_e8_office_hardening--disable_flash): Private class
* [`acsc_e8_office_hardening::macros`](#acsc_e8_office_hardening--macros): Private class
* [`acsc_e8_office_hardening::mount_default_user_hive`](#acsc_e8_office_hardening--mount_default_user_hive): Private class
* [`acsc_e8_office_hardening::trusted_locations`](#acsc_e8_office_hardening--trusted_locations): Private class
* [`acsc_e8_office_hardening::unmount_default_user_hive`](#acsc_e8_office_hardening--unmount_default_user_hive): Private class

### Defined types

* [`acsc_e8_office_hardening::delete_trusted_location`](#acsc_e8_office_hardening--delete_trusted_location): Private type
* [`acsc_e8_office_hardening::delete_user_registry_value`](#acsc_e8_office_hardening--delete_user_registry_value): Private type
* [`acsc_e8_office_hardening::set_trusted_location`](#acsc_e8_office_hardening--set_trusted_location): Private type
* [`acsc_e8_office_hardening::user_registry_value`](#acsc_e8_office_hardening--user_registry_value): Private type

## Classes

### <a name="acsc_e8_office_hardening"></a>`acsc_e8_office_hardening`

A module which enforces https://github.com/benjamin-robertson/acsc_e8_office_hardening/blob/main/PROTECT%20-%20Microsoft%20Office%20Macro%20Security%20(October%202021).pdf


lint:ignore:140chars

#### Examples

##### 

```puppet
include acsc_e8_office_hardening
```

#### Parameters

The following parameters are available in the `acsc_e8_office_hardening` class:

* [`disable_flash_content`](#-acsc_e8_office_hardening--disable_flash_content)
* [`disable_macros`](#-acsc_e8_office_hardening--disable_macros)
* [`set_ntuser_interval`](#-acsc_e8_office_hardening--set_ntuser_interval)
* [`macro_setting`](#-acsc_e8_office_hardening--macro_setting)
* [`trusted_locations`](#-acsc_e8_office_hardening--trusted_locations)

##### <a name="-acsc_e8_office_hardening--disable_flash_content"></a>`disable_flash_content`

Data type: `Boolean`

Disable flash content. Default: false

Default value: `false`

##### <a name="-acsc_e8_office_hardening--disable_macros"></a>`disable_macros`

Data type: `Boolean`

Disable macros, Default: true

Default value: `true`

##### <a name="-acsc_e8_office_hardening--set_ntuser_interval"></a>`set_ntuser_interval`

Data type: `Integer`

Set the interval to set the default ntuser macro settings in hours. Default: 1

Default value: `24`

##### <a name="-acsc_e8_office_hardening--macro_setting"></a>`macro_setting`

Data type: `Enum['all_macros_disabled','macros_from_trusted_locations','signed_macros_only','clear_macro_settings']`

Macro settings to enforce, for details see ACSC publication. Default: clear_macro_settings

Default value: `'clear_macro_settings'`

##### <a name="-acsc_e8_office_hardening--trusted_locations"></a>`trusted_locations`

Data type: `Variant[Undef,Hash[String,Hash,1,20]]`

Set trusted location. See example in readme. Default: undef

Default value: `undef`

### <a name="acsc_e8_office_hardening--clear_unused_registry_values"></a>`acsc_e8_office_hardening::clear_unused_registry_values`

Clear unused registry values when switching between office macro modes

#### Examples

##### 

```puppet
class { 'acsc_e8_office_hardening::clear_unused_registry_values':
  system_setting     => $facts['office_macro_last_run'],
  configured_setting => $macro_setting,
}
```

#### Parameters

The following parameters are available in the `acsc_e8_office_hardening::clear_unused_registry_values` class:

* [`system_setting`](#-acsc_e8_office_hardening--clear_unused_registry_values--system_setting)
* [`configured_setting`](#-acsc_e8_office_hardening--clear_unused_registry_values--configured_setting)

##### <a name="-acsc_e8_office_hardening--clear_unused_registry_values--system_setting"></a>`system_setting`

Data type: `String`

Current system macro setting

##### <a name="-acsc_e8_office_hardening--clear_unused_registry_values--configured_setting"></a>`configured_setting`

Data type: `String`

Configured system macro setting

### <a name="acsc_e8_office_hardening--disable_flash"></a>`acsc_e8_office_hardening::disable_flash`

Disables flash within office

#### Examples

##### 

```puppet
include acsc_e8_office_hardening::disable_flash
```

#### Parameters

The following parameters are available in the `acsc_e8_office_hardening::disable_flash` class:

* [`reg_values`](#-acsc_e8_office_hardening--disable_flash--reg_values)

##### <a name="-acsc_e8_office_hardening--disable_flash--reg_values"></a>`reg_values`

Data type: `Hash`

registry values to set

### <a name="acsc_e8_office_hardening--macros"></a>`acsc_e8_office_hardening::macros`

Configured office macro settings for office.
Private class

#### Examples

##### 

```puppet
include acsc_e8_office_hardening::macros
```

#### Parameters

The following parameters are available in the `acsc_e8_office_hardening::macros` class:

* [`macro_setting`](#-acsc_e8_office_hardening--macros--macro_setting)

##### <a name="-acsc_e8_office_hardening--macros--macro_setting"></a>`macro_setting`

Data type: `String`

set office macro setting

Default value: `'clear_macro_settings'`

### <a name="acsc_e8_office_hardening--mount_default_user_hive"></a>`acsc_e8_office_hardening::mount_default_user_hive`

Mounts the default user ntuser.dat file located under c:\user\default\ntuser.dat
Mounts under HKU\user_default
Private class

#### Examples

##### 

```puppet
include acsc_e8_office_hardening::mount_default_user_hive
```

### <a name="acsc_e8_office_hardening--trusted_locations"></a>`acsc_e8_office_hardening::trusted_locations`

Creates trusted locations for office
Private class

#### Examples

##### 

```puppet
include acsc_e8_office_hardening::trusted_locations
```

#### Parameters

The following parameters are available in the `acsc_e8_office_hardening::trusted_locations` class:

* [`trusted_locations`](#-acsc_e8_office_hardening--trusted_locations--trusted_locations)

##### <a name="-acsc_e8_office_hardening--trusted_locations--trusted_locations"></a>`trusted_locations`

Data type: `Hash`

Hash of trusted locations. See readme for example

### <a name="acsc_e8_office_hardening--unmount_default_user_hive"></a>`acsc_e8_office_hardening::unmount_default_user_hive`

Mounts the default user ntuser.dat file located under c:\user\default\ntuser.dat
Mounts under HKU\user_default
Private class

#### Examples

##### 

```puppet
include acsc_e8_office_hardening::unmount_default_user_hive
```

## Defined types

### <a name="acsc_e8_office_hardening--delete_trusted_location"></a>`acsc_e8_office_hardening::delete_trusted_location`

Delete trusted location if unmanaged by Pupppet
We handle up to 20 custom locations

#### Examples

##### 

```puppet
acsc_e8_office_hardening::delete_trusted_location { "location${delelete_index}":}
```

### <a name="acsc_e8_office_hardening--delete_user_registry_value"></a>`acsc_e8_office_hardening::delete_user_registry_value`

Defined type which deletes registry value for each HKEY_CURRENT_USER on a machine.

#### Examples

##### 

```puppet
acsc_e8_office_hardening::user_registry_value { 'key_name': }
```

#### Parameters

The following parameters are available in the `acsc_e8_office_hardening::delete_user_registry_value` defined type:

* [`key_name`](#-acsc_e8_office_hardening--delete_user_registry_value--key_name)

##### <a name="-acsc_e8_office_hardening--delete_user_registry_value--key_name"></a>`key_name`

Data type: `String`

key name to delete

### <a name="acsc_e8_office_hardening--set_trusted_location"></a>`acsc_e8_office_hardening::set_trusted_location`

Creates trusted location for office files.
This must be used in conjuntion with the macros_from_trusted_locations option.
Otherwise it will have affect.

#### Examples

##### 

```puppet
acsc_e8_office_hardening::set_trusted_location { 'namevar': }
```

#### Parameters

The following parameters are available in the `acsc_e8_office_hardening::set_trusted_location` defined type:

* [`path`](#-acsc_e8_office_hardening--set_trusted_location--path)
* [`date`](#-acsc_e8_office_hardening--set_trusted_location--date)
* [`description`](#-acsc_e8_office_hardening--set_trusted_location--description)
* [`allowsub`](#-acsc_e8_office_hardening--set_trusted_location--allowsub)

##### <a name="-acsc_e8_office_hardening--set_trusted_location--path"></a>`path`

Data type: `String`

File path to permit

##### <a name="-acsc_e8_office_hardening--set_trusted_location--date"></a>`date`

Data type: `Optional[Variant[String,Undef]]`

Date set. Default: undef

Default value: `undef`

##### <a name="-acsc_e8_office_hardening--set_trusted_location--description"></a>`description`

Data type: `Optional[Variant[String,Undef]]`

Description of path. Default: undef

Default value: `undef`

##### <a name="-acsc_e8_office_hardening--set_trusted_location--allowsub"></a>`allowsub`

Data type: `Boolean`

Permit sub directory under that path. Default: false

Default value: `false`

### <a name="acsc_e8_office_hardening--user_registry_value"></a>`acsc_e8_office_hardening::user_registry_value`

Defined type which sets registry value for each HKEY_CURRENT_USER on a machine.

#### Examples

##### 

```puppet
acsc_e8_office_hardening::user_registry_value { 'namevar': }
```

#### Parameters

The following parameters are available in the `acsc_e8_office_hardening::user_registry_value` defined type:

* [`key_name`](#-acsc_e8_office_hardening--user_registry_value--key_name)
* [`key_details`](#-acsc_e8_office_hardening--user_registry_value--key_details)

##### <a name="-acsc_e8_office_hardening--user_registry_value--key_name"></a>`key_name`

Data type: `String`

key name

##### <a name="-acsc_e8_office_hardening--user_registry_value--key_details"></a>`key_details`

Data type: `Hash`

Key details, hash containing value, type and data for registry value

